/* MAKI & MAG Library */

#ifndef NULL
#define NULL	0
#endif

#define FALSE	0
#define TRUE	-1
#define EOC		0x1a		/* End Of Comment */
#define CR		0x0d
#define LF		0x0a
#define BufSize	256

#define PLANE20	0x001c
#define PLANE21	0x0104
#define PLANE10	0x010c

#define PALNO	0xfd90
#define PALB	0xfd92
#define PALR	0xfd94
#define PALG	0xfd96

#define LINE200	0x01			/* 200CtO */
#define COL8	0x02			/* 8FtO */
#define DIGITAL	0x04			/* fW^tO */
#define COL256	0x80			/* 256FtO */

#define DOS		0x40			/* DOS݊ʃtO */
#define VRAM	0x20			/* uq`lWJtO */

#define Other	0x00			/* @R[hł */
#define MSX		0x03
#define PC88	0x88
#define X68K	0x68
#define Eseq	0xff

#define Scroll_UP		1
#define Scroll_DOWN		2
#define Scroll_RIGHT	3
#define Scroll_LEFT		4
#define Zoom_DOWN		5
#define Zoom_UP			6

typedef union {
	struct { unsigned char h,l; } m;
	unsigned short	s;
	} WORD;

typedef struct {
	char	header;			/* wb_̐擪 */
	char	machine;		/* @R[h */
	char	rflg;			/* @ˑtO */
	char	screen;			/* XN[[h */
	short	lx;				/* \Jnʒuw */
	short	ly;				/* \Jnʒux */
	short	rx;				/* \Iʒuw */
	short	ry;				/* \Iʒux */
	int		offa;			/* tO`̃ItZbg */
	int		offb;			/* tOãItZbg */
	int		sizb;			/* tOãTCY */
	int		offp;			/* sNZ̃ItZbg */
	int		sizp;			/* sNZ̃TCY */
	} MAGHEADER;

typedef struct {
	char	id[8];			/* MAKIʎq'MAKI01A ' or 'MAKI01B ' */
	char	comment[24];	/* Z[o[҃Rg */
	WORD	sizb;			/* tOãTCY */
	WORD	sizpa;			/* sNZ`̃TCY */
	WORD	sizpb;			/* sNZãTCY */
	WORD	tile;			/* ^Cf[^̃TCY */
	WORD	lx;				/* \Jnʒuw */
	WORD	ly;				/* \Jnʒux */
	WORD	rx;				/* \Iʒuw */
	WORD	ry;				/* \Iʒux */
	} MKIHEADER;

#if 0
typedef struct {
	Mdir	*next;
	char	fname[256];		/* pX&t@Cl[ */
	char	comment[81];	/* Rg̑O1C */
	int		header;			/* t@C擪̃wb_̃ItZbg */
	int		size;			/* t@CTCY */
	int		lx,ly;			/* W */
	int		rx,ry;			/* EW */
	} Mdir;
#endif

/* Global Vari. */

extern MAGHEADER	maghead;					/* MAG̃wb_[ */
extern MKIHEADER	mkihead;					/* MAKĨxb_[ */
extern int			siza;
extern char			egbwork[];					/* EGBCup[N */
extern char			pal[768];					/* ݂̃pbg */
extern char			*flga,*flgb,*flg,*pix;		/* flag&pixeli[AhX */
	/* ݃ɑ݂C[W */
extern char			*vram;						/* C[Wi[AhX */
extern int			screen_mode;				/* XN[[h(MAG݊) */
extern int			image_mode;					/* ̃f[^̃[h */
extern int			lx,ly;						/* W */
extern int			rx,ry;						/* EW */
extern char			comment[81];				/* Rg */

/* MAKI Load Library */
extern int		mki_get_head(FILE *fp);
extern int		mki_decode(FILE *fp,int mode,int x,int y);

/* MAG Load Library */
extern int		mag_get_head(FILE *fp);
extern int		mag_decode(FILE *fp,int mode,int x,int y);

/* Display Library */
extern int		display(int slx,int sly,int ssx,int ssy,int dx,int dy);
/*
 *	Memory to Vram copy function
 *		int slx,sly;		Memory̓]W
 *		int ssx,ssy;		]TCY
 *		int dx,dy;			VRAM̓]捶W
 */
extern int		set_palette();
extern int		stringcmp(char *s,char *d);

/* MAG Save Library */

/* AH :-) */

